library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity module_G is
    generic (G_N : natural := 24);
    port (
        I_din  : in  std_logic_vector(G_N-1 downto 0);
        O_dout : out std_logic_vector(G_N-1 downto 0)
        );
end module_G;

architecture behavioral of module_G is

    --Min and max values of signed signals
    constant C_min_val : std_logic_vector := std_logic_vector(to_signed(-2**(G_N-1), G_N));
    constant C_max_val : std_logic_vector := std_logic_vector(to_signed(2**(G_N-1)-1, G_N));

begin

    O_dout <= C_max_val when I_din = C_min_val else std_logic_vector(-signed(I_din));
-- be careful: this test suggests that a clipping error of one LSB is accepted.
end behavioral;
