library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity module_I is
    generic (
        G_N : natural := 8
        );
    port (
        I_clk  : in  std_logic;
        I_rst  : in  std_logic;
        I_din  : in  std_logic_vector(G_N-1 downto 0);
        O_dout : out std_logic_vector(G_N-1 downto 0)
        );
end module_I;

architecture behavioral of module_I is

    signal SR_dout : std_logic_vector(G_N-1 downto 0) := (others => '0');

begin

    process(I_clk)
    begin
        if rising_edge(I_clk) then
            if I_rst = '1' then
                SR_dout <= (others => '0');
            else
                SR_dout <= I_din;
            end if;
        end if;
    end process;

    O_dout <= SR_dout;

end behavioral;
