library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tb_module_F is
end tb_module_F;

architecture behavioral of tb_module_F is

    component module_F is
        port (
            I_sel                          : in  std_logic_vector(1 downto 0);
            I_din0, I_din1, I_din2, I_din3 : in  std_logic_vector;
            O_dout                         : out std_logic_vector);
    end component module_F;

    constant C_Size : natural := 16;

    signal SC_sel  : std_logic_vector(1 downto 0);
    signal SC_din0 : std_logic_vector(C_Size -1 downto 0) := std_logic_vector(to_unsigned(3, C_Size));
    signal SC_din1 : std_logic_vector(C_Size -1 downto 0) := std_logic_vector(to_unsigned(5, C_Size));
    signal SC_din2 : std_logic_vector(C_Size -1 downto 0) := std_logic_vector(to_unsigned(8, C_Size));
    signal SC_din3 : std_logic_vector(C_Size -1 downto 0) := std_logic_vector(to_unsigned(12, C_Size));
    signal SC_dout : std_logic_vector(C_Size -1 downto 0);

begin

    SC_sel <= "00", "01" after 33 ns, "10" after 66 ns, "11" after 99 ns;

    module_F_1 : entity work.module_F
        port map (
            I_sel  => SC_sel,
            I_din0 => SC_din0,
            I_din1 => SC_din1,
            I_din2 => SC_din2,
            I_din3 => SC_din3,
            O_dout => SC_dout
            );

end behavioral;
