library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tb_module_H is
end tb_module_H;

architecture behavioral of tb_module_H is

    component module_H is
        port (
            I_sel          : in  std_logic;
            I_din0, I_din1 : in  std_logic_vector;
            O_dout         : out std_logic_vector
            );
    end component module_H;

    constant C_Size : natural := 16;

    signal SC_sel  : std_logic;
    signal SC_din0 : std_logic_vector(C_Size - 1 downto 0) := std_logic_vector(to_unsigned(5, C_Size));
    signal SC_din1 : std_logic_vector(C_Size - 1 downto 0) := std_logic_vector(to_unsigned(12, C_Size));
    signal SC_dout : std_logic_vector(C_Size - 1 downto 0);

begin

    SC_sel <= '0', '1' after 33 ns, '0' after 66 ns, '1' after 99 ns;

    module_H_1 : entity work.module_H
        port map (
            I_sel  => SC_sel,
            I_din0 => SC_din0,
            I_din1 => SC_din1,
            O_dout => SC_dout);

end behavioral;
