library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity tb_module_I is
end tb_module_I;

architecture behavioral of tb_module_I is

    component module_I is
        generic (
            G_N : natural := 8
            );
        port (
            I_clk  : in  std_logic;
            I_rst  : in  std_logic;
            I_din  : in  std_logic_vector(G_N-1 downto 0);
            O_dout : out std_logic_vector(G_N-1 downto 0)
            );
    end component module_I;

    constant C_Size : natural := 16;

    signal SR_clk  : std_logic := '1';
    signal SR_rst  : std_logic := '0';
    signal SR_din  : std_logic_vector(C_Size-1 downto 0);
    signal SC_dout : std_logic_vector(C_Size-1 downto 0);

begin

    SR_rst <= '0', '1' after 29 ns, '0' after 57 ns;

    SR_clk <= not SR_clk after 7 ns;

    SR_din <= std_logic_vector(to_unsigned(3, C_Size)),
              std_logic_vector(to_unsigned(7, C_Size))  after 87 ns,
              std_logic_vector(to_unsigned(13, C_Size)) after 129 ns;

    module_I_1 : entity work.module_I
        generic map (
            G_N => C_Size)
        port map (
            I_clk  => SR_clk,
            I_rst  => SR_rst,
            I_din  => SR_din,
            O_dout => SC_dout);


end behavioral;
